Loading...
Searching...
No Matches
Dune::Preconditioner< X, Y > Class Template Referenceabstract
Iterative Solvers Template Library (ISTL) » Iterative Solvers » Preconditioners

Base class for matrix free definition of preconditioners. More...

`#include <dune/istl/preconditioner.hh>`

Inheritance diagram for Dune::Preconditioner< X, Y >:

## Public Types

typedef X | domain_type
| The domain type of the preconditioner.
typedef Y | range_type
| The range type of the preconditioner.
typedef X::field_type | field_type
| The field type of the preconditioner.

## Public Member Functions

virtual void | pre (X &x, Y &b)=0
| Prepare the preconditioner.
virtual void | apply (X &v, const Y &d)=0
| Apply one step of the preconditioner to the system A(v)=d.
virtual void | post (X &x)=0
| Clean up.
virtual SolverCategory::Category | category () const =0
| Category of the preconditioner (see SolverCategory::Category).
virtual | ~Preconditioner ()
| every abstract base class has a virtual destructor

## Detailed Description

template<class X, class Y>
class Dune::Preconditioner< X, Y >

Base class for matrix free definition of preconditioners.

Note that the operator, which is the basis for the preconditioning, is supplied to the preconditioner from the outside in the constructor or some other method.

This interface allows the encapsulation of all parallelization aspects into the preconditioners.

Template Parameters

  X | Type of the update
  Y | Type of the defect

## Member Typedef Documentation

## domain_type

template<class X, class Y>

typedef X Dune::Preconditioner< X, Y >::domain_type

The domain type of the preconditioner.

## field_type

template<class X, class Y>

typedef X::field_type Dune::Preconditioner< X, Y >::field_type

The field type of the preconditioner.

## range_type

template<class X, class Y>

typedef Y Dune::Preconditioner< X, Y >::range_type

The range type of the preconditioner.

## Constructor & Destructor Documentation

## ~Preconditioner()

template<class X, class Y>

virtual Dune::Preconditioner< X, Y >::~Preconditioner | ( |  | ) |

inline virtual

every abstract base class has a virtual destructor

## Member Function Documentation

## apply()

template<class X, class Y>

virtual void Dune::Preconditioner< X, Y >::apply | ( | X & | v,
|  | const Y & | d )

pure virtual

Apply one step of the preconditioner to the system A(v)=d.

On entry v=0 and d=b-A(x) (although this might not be computed in that way. On exit v contains the update, i.e one step computes where is the approximate inverse of the operator characterizing the preconditioner.

Parameters

  [out] | v | The update to be computed
  | d | The current defect.

Implemented in Dune::Amg::AMG< M, X, S, PI, A >, Dune::Amg::AMG< M, X, S, PI, A >, Dune::Amg::AMG< M, X, S, SequentialInformation, std::allocator< X > >, Dune::Amg::AMG< Operator, X, Smoother >, Dune::Amg::FastAMG< M, X, PI, A >, Dune::BlockPreconditioner< X, Y, C, P >, Dune::BlockPreconditioner< X, Y, C, P >, Dune::BlockPreconditioner< X, Y, C, SeqSOR< M, X, Y, l > >, Dune::BlockPreconditioner< X, Y, C, SeqSOR< M, X, Y, l > >, Dune::InverseOperator2Preconditioner< O, c >, Dune::NonoverlappingBlockPreconditioner< C, P >, Dune::NonoverlappingBlockPreconditioner< C, P >, Dune::ParSSOR< M, X, Y, C >, Dune::Richardson< X, Y >, Dune::SeqDILU< M, X, Y, l >, Dune::SeqILDL< M, X, Y >, Dune::SeqILU< M, X, Y, l >, Dune::SeqJac< M, X, Y, l >, Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >, Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >, Dune::SeqOverlappingSchwarz< M, X, MultiplicativeSchwarzMode, MS, TA >, Dune::SeqOverlappingSchwarz< M, X, MultiplicativeSchwarzMode, MS, TA >, Dune::SeqOverlappingSchwarz< M, X, SymmetricMultiplicativeSchwarzMode, TD, TA >, Dune::SeqOverlappingSchwarz< M, X, SymmetricMultiplicativeSchwarzMode, TD, TA >, Dune::SeqOverlappingSchwarz< M, X, TM, TS, TA >, Dune::SeqSOR< M, X, Y, l >, Dune::SeqSOR< M, X, Y, l >, Dune::SeqSOR< M, X, Y, l >, Dune::SeqSOR< M, X, Y, l >, Dune::SeqSSOR< M, X, Y, l >, Dune::SeqSSOR< typename M::matrix_type, X, X >, Dune::subdomain_vector< M, X, TM, TS, TA >, and Dune::subdomain_vector< M, X, TM, TS, TA >.

## category()

template<class X, class Y>

virtual SolverCategory::Category Dune::Preconditioner< X, Y >::category | ( |  | ) | const

pure virtual

Category of the preconditioner (see SolverCategory::Category).

Implemented in Dune::Amg::AMG< M, X, S, PI, A >, Dune::Amg::AMG< M, X, S, PI, A >, Dune::Amg::AMG< M, X, S, SequentialInformation, std::allocator< X > >, Dune::Amg::AMG< Operator, X, Smoother >, Dune::Amg::FastAMG< M, X, PI, A >, Dune::Amg::KAMG< M, X, S, PI, K, A >, Dune::Amg::KAmgTwoGrid< AMG >, Dune::Amg::KAmgTwoGrid< Dune::Amg::AMG< M, X, S, SequentialInformation, std::allocator< X > > >, Dune::Amg::TwoLevelMethod< FO, CSP, S >, Dune::BlockPreconditioner< X, Y, C, P >, Dune::BlockPreconditioner< X, Y, C, SeqSOR< M, X, Y, l > >, Dune::InverseOperator2Preconditioner< O, c >, Dune::NonoverlappingBlockPreconditioner< C, P >, Dune::NonoverlappingBlockPreconditioner< C, SeqSOR< M, X, Y, l > >, Dune::ParSSOR< M, X, Y, C >, Dune::Richardson< X, Y >, Dune::SeqDILU< M, X, Y, l >, Dune::SeqILDL< M, X, Y >, Dune::SeqILU< M, X, Y, l >, Dune::SeqJac< M, X, Y, l >, Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >, Dune::SeqOverlappingSchwarz< M, X, MultiplicativeSchwarzMode, MS, TA >, Dune::SeqOverlappingSchwarz< M, X, SymmetricMultiplicativeSchwarzMode, TD, TA >, Dune::SeqOverlappingSchwarz< M, X, TM, TS, TA >, Dune::SeqSOR< M, X, Y, l >, Dune::SeqSOR< M, X, Y, l >, Dune::SeqSSOR< M, X, Y, l >, Dune::SeqSSOR< typename M::matrix_type, X, X >, and Dune::subdomain_vector< M, X, TM, TS, TA >.

## post()

template<class X, class Y>

virtual void Dune::Preconditioner< X, Y >::post | ( | X & | x | ) |

pure virtual

Clean up.

This method is called after the last apply call for the linear system to be solved. Memory may be deallocated safely here. x is the solution of the linear equation.

Parameters

  x | The right hand side of the equation.

Implemented in Dune::Amg::AMG< M, X, S, PI, A >, Dune::Amg::AMG< M, X, S, PI, A >, Dune::Amg::AMG< M, X, S, SequentialInformation, std::allocator< X > >, Dune::Amg::AMG< Operator, X, Smoother >, Dune::Amg::FastAMG< M, X, PI, A >, Dune::BlockPreconditioner< X, Y, C, P >, Dune::BlockPreconditioner< X, Y, C, SeqSOR< M, X, Y, l > >, Dune::InverseOperator2Preconditioner< O, c >, Dune::NonoverlappingBlockPreconditioner< C, P >, Dune::ParSSOR< M, X, Y, C >, Dune::Richardson< X, Y >, Dune::SeqDILU< M, X, Y, l >, Dune::SeqILDL< M, X, Y >, Dune::SeqILU< M, X, Y, l >, Dune::SeqJac< M, X, Y, l >, Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >, Dune::SeqOverlappingSchwarz< M, X, MultiplicativeSchwarzMode, MS, TA >, Dune::SeqOverlappingSchwarz< M, X, SymmetricMultiplicativeSchwarzMode, TD, TA >, Dune::SeqOverlappingSchwarz< M, X, TM, TS, TA >, Dune::SeqSOR< M, X, Y, l >, Dune::SeqSOR< M, X, Y, l >, Dune::SeqSSOR< M, X, Y, l >, Dune::SeqSSOR< typename M::matrix_type, X, X >, and Dune::subdomain_vector< M, X, TM, TS, TA >.

## pre()

template<class X, class Y>

virtual void Dune::Preconditioner< X, Y >::pre | ( | X & | x,
|  | Y & | b )

pure virtual

Prepare the preconditioner.

A solver solves a linear operator equation A(x)=b by applying one or several steps of the preconditioner. The method pre() is called before the first apply operation. b and x are right hand side and solution vector of the linear system respectively. It may. e.g., scale the system, allocate memory or compute a (I)LU decomposition. Note: The ILU decomposition could also be computed in the constructor or with a separate method of the derived method if several linear systems with the same matrix are to be solved.

Note
  if a preconditioner is copied (e.g. for a second thread) again the pre() method has to be called to ensure proper memory management.

X x(0.0);
Y b = ...; // rhs
Preconditioner<X,Y> prec(...);
prec.pre(x,b); // prepare the preconditioner
prec.apply(x,b); // can be called multiple times now...
prec.post(x); // cleanup internal state
Dune::Preconditioner
Base class for matrix free definition of preconditioners.
Definition preconditioner.hh:33

Parameters

  x | The left hand side of the equation.
  b | The right hand side of the equation.

Implemented in Dune::Amg::AMG< M, X, S, PI, A >, Dune::Amg::AMG< M, X, S, PI, A >, Dune::Amg::AMG< M, X, S, SequentialInformation, std::allocator< X > >, Dune::Amg::AMG< Operator, X, Smoother >, Dune::Amg::FastAMG< M, X, PI, A >, Dune::BlockPreconditioner< X, Y, C, P >, Dune::BlockPreconditioner< X, Y, C, SeqSOR< M, X, Y, l > >, Dune::InverseOperator2Preconditioner< O, c >, Dune::NonoverlappingBlockPreconditioner< C, P >, Dune::ParSSOR< M, X, Y, C >, Dune::Richardson< X, Y >, Dune::SeqDILU< M, X, Y, l >, Dune::SeqILDL< M, X, Y >, Dune::SeqILU< M, X, Y, l >, Dune::SeqJac< M, X, Y, l >, Dune::SeqOverlappingSchwarz< M, X, TM, TD, TA >, Dune::SeqOverlappingSchwarz< M, X, MultiplicativeSchwarzMode, MS, TA >, Dune::SeqOverlappingSchwarz< M, X, SymmetricMultiplicativeSchwarzMode, TD, TA >, Dune::SeqOverlappingSchwarz< M, X, TM, TS, TA >, Dune::SeqSOR< M, X, Y, l >, Dune::SeqSOR< M, X, Y, l >, Dune::SeqSSOR< M, X, Y, l >, Dune::SeqSSOR< typename M::matrix_type, X, X >, and Dune::subdomain_vector< M, X, TM, TS, TA >.

The documentation for this class was generated from the following file:

- preconditioner.hh